summaryrefslogtreecommitdiffstats
path: root/desktop/amiwm/amiwm.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'desktop/amiwm/amiwm.SlackBuild')
-rw-r--r--desktop/amiwm/amiwm.SlackBuild134
1 files changed, 134 insertions, 0 deletions
diff --git a/desktop/amiwm/amiwm.SlackBuild b/desktop/amiwm/amiwm.SlackBuild
new file mode 100644
index 0000000000..bf3040c140
--- /dev/null
+++ b/desktop/amiwm/amiwm.SlackBuild
@@ -0,0 +1,134 @@
+#!/bin/bash
+
+# Slackware build script for amiwm
+
+# Written by B. Watson (urchlay@slackware.uk)
+
+# Licensed under the WTFPL. See http://www.wtfpl.net/txt/copying/ for details.
+
+# This thing is very early-90s, and not very much fun to use (even
+# for me, who prefers WindowMaker). However, I never had an Amiga;
+# for someone who grew up with one, maybe this is how they expect GUIs
+# to work.
+
+# 20230427 bkw: update for v0.22pl2.
+# - Switched upstreams. Apparently the github version I packaged was a
+# fork. Now I'm using the actual author's version. Thanks to luna on
+# IRC for finding the original site and the new release (also for
+# testing the previous version).
+# - Fix issue with parallel make.
+# - Clean up man page slightly.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=amiwm
+VERSION=${VERSION:-0.22pl2}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM$VERSION
+tar xvf $CWD/$PRGNAM$VERSION.tar.gz
+cd $PRGNAM$VERSION
+chown -R root:root .
+# permissions are awful, don't revert to template here.
+find -L . -type d -a -exec chmod 755 {} \+ -o \
+ -type f -a -exec chmod 644 {} \+
+
+LIB=lib$LIBDIRSUFFIX
+LIBDIR=/usr/$LIB
+
+# hardcoded wrong path in config file.
+sed -i "s,/usr/local/lib,$LIBDIR," system.amiwmrc
+
+# 20230427 bkw: man page has confusing wording. also left curly
+# quotes, but the right quotes are straight, which is weird-looking.
+sed -i -e 's,amiwmrc-file,amiwmrc file,' \
+ -e 's,\\f1\\\*(lq\\f3,",g' \
+ amiwm.1
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+sh ./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --sysconfdir=/etc \
+ --localstatedir=/var \
+ --mandir=/usr/man \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --build=$ARCH-slackware-linux
+
+# --libdir doesn't work as usual, and there's no DESTDIR support.
+# install-strip isn't supported, but not needed (make install will
+# strip the binaries).
+# have to make the X* files here to avoid having $PKG in them,
+# though it doesn't really matter (we don't use these, they're
+# just there for reference I guess).
+# 20230427 bkw: it occasionally fails with -jN (but not always),
+# because gram.h isn't made before it's needed. so make it first.
+make gram.h
+make libdir=$LIBDIR all Xinitrc Xsession Xsession2
+make install prefix=$PKG/usr libdir=$PKG/$LIBDIR
+gzip -9 $PKG/usr/man/man*/*.*
+
+# this symlink ends up absolute, with $PKG in the path.
+rm -f $PKG/usr/bin/requestchoice
+ln -s ../$LIB/$PRGNAM/requestchoice $PKG/usr/bin/requestchoice
+
+# xinitrc.amiwm adapted from Slackware's xinitrc.wmaker
+install -D -oroot -groot -m0755 \
+ $CWD/xinitrc.$PRGNAM \
+ $PKG/etc/X11/xinit/xinitrc.$PRGNAM
+
+# make this a .new config file, although since it's not in /etc,
+# "slackpkg new-config" won't ever prompt for it (not really a
+# problem, this isn't a core Slackware package anyway).
+rename rc rc.new $PKG/$LIBDIR/$PRGNAM/system.amiwmrc
+
+PKGDOC=$PKG/usr/doc/$PRGNAM-$VERSION
+mkdir -p $PKGDOC
+cp -a README* LICENSE* $PKGDOC
+cat $CWD/$PRGNAM.SlackBuild > $PKGDOC/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+sed "s,@LIB@,$LIB," < $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE